/*
Copyright 2015-2022 Ian Jauslin

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/* correspondence table to group a polynomial into a flow equation */

#ifndef IDTABLE_H
#define IDTABLE_H

#include "types.h"

// allocate memory
int init_Id_Table(Id_Table* idtable,int size);
// free memory
int free_Id_Table(Id_Table idtable);

// resize the memory allocated to a idtable
int resize_idtable(Id_Table* idtable,int new_size);

// copy an idtable
int idtable_cpy(Id_Table input, Id_Table* output);
int idtable_cpy_noinit(Id_Table input, Id_Table* output);

// append an element to a idtable
int idtable_append(int index, Polynomial polynomial, Id_Table* output);
int idtable_append_noinit(int index, Polynomial polynomial, Id_Table* output);

// concatenate two idtables
int idtable_concat(Id_Table input, Id_Table* output);

#define IDTABLE_H_DONE
#endif
