/*
Copyright 2015-2022 Ian Jauslin

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/*
 RCC_mpfr struct
 
 This data type is similar to RCC but the values of the rcc's are specified as mpfr floats
*/

#ifndef RCC_MPFR_H
#define RCC_MPFR_H

#include "types.h"

// init
int init_RCC_mpfr(RCC_mpfr* rcc_mpfr, int size);
int free_RCC_mpfr(RCC_mpfr rcc_mpfr);
// set an element of an rcc_mpfr
int RCC_mpfr_set_elem(mpfr_t value, int index, RCC_mpfr* rcc_mpfr, int pos);
// copy
int RCC_mpfr_cpy(RCC_mpfr input,RCC_mpfr* output);
int RCC_mpfr_cpy_noinit(RCC_mpfr input,RCC_mpfr* output);
// concatenate 2 rcc_mpfr_mpfr
int RCC_mpfr_concat(RCC_mpfr rcc_mpfr_mpfr1, RCC_mpfr rcc_mpfr_mpfr2, RCC_mpfr* output);
// append an rcc_mpfr to another
int RCC_mpfr_append(RCC_mpfr input, RCC_mpfr* output);

// print an rcc_mpfr vector with maximal precision
int RCC_mpfr_print(RCC_mpfr rcc_mpfr_mpfr);

#endif
