/*
Copyright 2015-2022 Ian Jauslin

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/* Trees */

#ifndef TREE_H
#define TREE_H

#include "types.h"

int init_Tree(Tree* tree, int memory_children, int memory_label);
int free_Tree(Tree tree);

// copy
int tree_cpy(Tree input, Tree* output);
int tree_cpy_noinit(Tree input, Tree* output);

// resize memory
int tree_resize(Tree* tree, int newsize);

// set label
int tree_set_label(Char_Array label, Tree* tree);

// add a child to a tree
int tree_append_child(Tree tree, Tree* output);
// add a child to a tree without allocating memory for the new child
int tree_append_child_noinit(Tree tree, Tree* output);

// concatenate the children of two trees
int tree_concat_children(Tree input, Tree* output);
// noinit
int tree_concat_children_noinit(Tree input, Tree* output);

#endif

